## victoriametrics 1.75.0+ds1

=== Makefile ===
PKG_PREFIX := github.com/VictoriaMetrics/VictoriaMetrics

DATEINFO_TAG ?= $(shell date -u +'%Y%m%d-%H%M%S')
BUILDINFO_TAG ?= $(shell echo $$(git describe --long --all | tr '/' '-')$$( \
	      git diff-index --quiet HEAD -- || echo '-dirty-'$$(git diff-index -u HEAD | openssl sha1 | cut -c 10-17)))

PKG_TAG ?= $(shell git tag -l --points-at HEAD)
ifeq ($(PKG_TAG),)
PKG_TAG := $(BUILDINFO_TAG)
endif

GO_BUILDINFO = -X '$(PKG_PREFIX)/lib/buildinfo.Version=$(APP_NAME)-$(DATEINFO_TAG)-$(BUILDINFO_TAG)'

.PHONY: $(MAKECMDGOALS)

all: \
	victoria-metrics-prod \
	vmagent-prod \
	vmalert-prod \
	vmauth-prod \
	vmbackup-prod \
	vmrestore-prod \
	vmctl-prod

include app/*/Makefile
include deployment/*/Makefile
include snap/local/Makefile


clean:
	rm -rf bin/*

publish: \
	publish-victoria-metrics \
	publish-vmagent \
	publish-vmalert \
	publish-vmauth \
	publish-vmbackup \
	publish-vmrestore \
	publish-vmctl

package: \
	package-victoria-metrics \
	package-vmagent \
	package-vmalert \
	package-vmauth \
	package-vmbackup \
	package-vmrestore \
	package-vmctl

vmutils: \
	vmagent \
	vmalert \
	vmauth \
	vmbackup \
	vmrestore \
	vmctl

vmutils-pure: \
	vmagent-pure \
	vmalert-pure \
	vmauth-pure \
	vmbackup-pure \
	vmrestore-pure \
	vmctl-pure

vmutils-arm64: \
	vmagent-arm64 \
	vmalert-arm64 \
	vmauth-arm64 \
	vmbackup-arm64 \
	vmrestore-arm64 \
	vmctl-arm64

vmutils-arm: \
	vmagent-arm \
	vmalert-arm \
	vmauth-arm \
	vmbackup-arm \
	vmrestore-arm \
	vmctl-arm

vmutils-windows-amd64: \
	vmagent-windows-amd64 \
	vmalert-windows-amd64 \
	vmauth-windows-amd64 \
	vmctl-windows-amd64


publish-release:
	git checkout $(TAG) && $(MAKE) release publish && \
		git checkout $(TAG)-cluster && $(MAKE) release publish && \
		git checkout $(TAG)-enterprise && $(MAKE) release publish && \
		git checkout $(TAG)-enterprise-cluster && $(MAKE) release publish

release: \
	release-victoria-metrics \
	release-vmutils

release-victoria-metrics: \
	release-victoria-metrics-amd64 \
	release-victoria-metrics-arm \
	release-victoria-metrics-arm64 \
	release-victoria-metrics-darwin-amd64 \
	release-victoria-metrics-darwin-arm64

release-victoria-metrics-amd64:
	OSARCH=amd64 $(MAKE) release-victoria-metrics-generic

release-victoria-metrics-arm:
	OSARCH=arm $(MAKE) release-victoria-metrics-generic

release-victoria-metrics-arm64:
	OSARCH=arm64 $(MAKE) release-victoria-metrics-generic

release-victoria-metrics-darwin-amd64:
	OSARCH=darwin-amd64 $(MAKE) release-victoria-metrics-generic

release-victoria-metrics-darwin-arm64:
	OSARCH=darwin-arm64 $(MAKE) release-victoria-metrics-generic

release-victoria-metrics-generic: victoria-metrics-$(OSARCH)-prod
	cd bin && \
		tar --transform="flags=r;s|-$(OSARCH)||" -czf victoria-metrics-$(OSARCH)-$(PKG_TAG).tar.gz \
			victoria-metrics-$(OSARCH)-prod \
		&& sha256sum victoria-metrics-$(OSARCH)-$(PKG_TAG).tar.gz \
			victoria-metrics-$(OSARCH)-prod \
			| sed s/-$(OSARCH)-prod/-prod/ > victoria-metrics-$(OSARCH)-$(PKG_TAG)_checksums.txt

release-vmutils: \
	release-vmutils-amd64 \
	release-vmutils-arm64 \
	release-vmutils-arm \
	release-vmutils-darwin-amd64  \
	release-vmutils-darwin-arm64 \
	release-vmutils-windows-amd64

release-vmutils-amd64:
	OSARCH=amd64 $(MAKE) release-vmutils-generic

release-vmutils-arm64:
	OSARCH=arm64 $(MAKE) release-vmutils-generic

release-vmutils-arm:
	OSARCH=arm $(MAKE) release-vmutils-generic

release-vmutils-darwin-amd64:
	OSARCH=darwin-amd64 $(MAKE) release-vmutils-generic

release-vmutils-darwin-arm64:
	OSARCH=darwin-arm64 $(MAKE) release-vmutils-generic

release-vmutils-windows-amd64:
	GOARCH=amd64 $(MAKE) release-vmutils-windows-generic

release-vmutils-generic: \
	vmagent-$(OSARCH)-prod \
	vmalert-$(OSARCH)-prod \
	vmauth-$(OSARCH)-prod \
	vmbackup-$(OSARCH)-prod \
	vmrestore-$(OSARCH)-prod \
	vmctl-$(OSARCH)-prod
	cd bin && \
		tar --transform="flags=r;s|-$(OSARCH)||" -czf vmutils-$(OSARCH)-$(PKG_TAG).tar.gz \
			vmagent-$(OSARCH)-prod \
			vmalert-$(OSARCH)-prod \
			vmauth-$(OSARCH)-prod \
			vmbackup-$(OSARCH)-prod \
			vmrestore-$(OSARCH)-prod \
			vmctl-$(OSARCH)-prod \
		&& sha256sum vmutils-$(OSARCH)-$(PKG_TAG).tar.gz \
			vmagent-$(OSARCH)-prod \
			vmalert-$(OSARCH)-prod \
			vmauth-$(OSARCH)-prod \
			vmbackup-$(OSARCH)-prod \
			vmrestore-$(OSARCH)-prod \
			vmctl-$(OSARCH)-prod \
			| sed s/-$(OSARCH)-prod/-prod/ > vmutils-$(OSARCH)-$(PKG_TAG)_checksums.txt

release-vmutils-windows-generic: \
	vmagent-windows-$(GOARCH)-prod \
	vmalert-windows-$(GOARCH)-prod \
	vmauth-windows-$(GOARCH)-prod \
	vmctl-windows-$(GOARCH)-prod
	cd bin && \
		zip vmutils-windows-$(GOARCH)-$(PKG_TAG).zip \
			vmagent-windows-$(GOARCH)-prod.exe \
			vmalert-windows-$(GOARCH)-prod.exe \
			vmauth-windows-$(GOARCH)-prod.exe \
			vmctl-windows-$(GOARCH)-prod.exe \
		&& sha256sum vmutils-windows-$(GOARCH)-$(PKG_TAG).zip \
			vmagent-windows-$(GOARCH)-prod.exe \
			vmalert-windows-$(GOARCH)-prod.exe \
			vmauth-windows-$(GOARCH)-prod.exe \
			vmctl-windows-$(GOARCH)-prod.exe \
			> vmutils-windows-$(GOARCH)-$(PKG_TAG)_checksums.txt


pprof-cpu:
	go tool pprof -trim_path=github.com/VictoriaMetrics/VictoriaMetrics@ $(PPROF_FILE)

fmt:
	GO111MODULE=on gofmt -l -w -s ./lib
	GO111MODULE=on gofmt -l -w -s ./app

vet:
	GO111MODULE=on go vet -mod=vendor ./lib/...
	GO111MODULE=on go vet -mod=vendor ./app/...

lint: install-golint
	golint lib/...
	golint app/...

install-golint:
	which golint || GO111MODULE=off go get golang.org/x/lint/golint

errcheck: install-errcheck
	errcheck -exclude=errcheck_excludes.txt ./lib/...
	errcheck -exclude=errcheck_excludes.txt ./app/vminsert/...
	errcheck -exclude=errcheck_excludes.txt ./app/vmselect/...
	errcheck -exclude=errcheck_excludes.txt ./app/vmstorage/...
	errcheck -exclude=errcheck_excludes.txt ./app/vmagent/...
	errcheck -exclude=errcheck_excludes.txt ./app/vmalert/...
	errcheck -exclude=errcheck_excludes.txt ./app/vmauth/...
	errcheck -exclude=errcheck_excludes.txt ./app/vmbackup/...
	errcheck -exclude=errcheck_excludes.txt ./app/vmrestore/...
	errcheck -exclude=errcheck_excludes.txt ./app/vmctl/...

install-errcheck:
	which errcheck || GO111MODULE=off go get github.com/kisielk/errcheck

check-all: fmt vet lint errcheck golangci-lint

test:
	GO111MODULE=on go test -mod=vendor ./lib/... ./app/...

test-race:
	GO111MODULE=on go test -mod=vendor -race ./lib/... ./app/...

test-pure:
	GO111MODULE=on CGO_ENABLED=0 go test -mod=vendor ./lib/... ./app/...

test-full:
	GO111MODULE=on go test -mod=vendor -coverprofile=coverage.txt -covermode=atomic ./lib/... ./app/...

test-full-386:
	GO111MODULE=on GOARCH=386 go test -mod=vendor -coverprofile=coverage.txt -covermode=atomic ./lib/... ./app/...

benchmark:
	GO111MODULE=on go test -mod=vendor -bench=. ./lib/...
	GO111MODULE=on go test -mod=vendor -bench=. ./app/...

benchmark-pure:
	GO111MODULE=on CGO_ENABLED=0 go test -mod=vendor -bench=. ./lib/...
	GO111MODULE=on CGO_ENABLED=0 go test -mod=vendor -bench=. ./app/...

vendor-update:
	GO111MODULE=on go get -u -d ./lib/...
	GO111MODULE=on go get -u -d ./app/...
	GO111MODULE=on go mod tidy
	GO111MODULE=on go mod vendor

app-local:
	CGO_ENABLED=1 GO111MODULE=on go build $(RACE) -mod=vendor -ldflags "$(GO_BUILDINFO)" -o bin/$(APP_NAME)$(RACE) $(PKG_PREFIX)/app/$(APP_NAME)

app-local-pure:
	CGO_ENABLED=0 GO111MODULE=on go build $(RACE) -mod=vendor -ldflags "$(GO_BUILDINFO)" -o bin/$(APP_NAME)-pure$(RACE) $(PKG_PREFIX)/app/$(APP_NAME)

app-local-with-goarch:
	GO111MODULE=on go build $(RACE) -mod=vendor -ldflags "$(GO_BUILDINFO)" -o bin/$(APP_NAME)-$(GOARCH)$(RACE) $(PKG_PREFIX)/app/$(APP_NAME)

app-local-windows-with-goarch:
	CGO_ENABLED=0 GO111MODULE=on go build $(RACE) -mod=vendor -ldflags "$(GO_BUILDINFO)" -o bin/$(APP_NAME)-windows-$(GOARCH)$(RACE).exe $(PKG_PREFIX)/app/$(APP_NAME)

quicktemplate-gen: install-qtc
	qtc

install-qtc:
	which qtc || GO111MODULE=off go get github.com/valyala/quicktemplate/qtc


golangci-lint: install-golangci-lint
	golangci-lint run --exclude '(SA4003|SA1019|SA5011):' -D errcheck -D structcheck --timeout 2m

install-golangci-lint:
	which golangci-lint || curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $(shell go env GOPATH)/bin v1.44.1

install-wwhrd:
	which wwhrd || GO111MODULE=off go get github.com/frapposelli/wwhrd

check-licenses: install-wwhrd
	wwhrd check -f .wwhrd.yml

copy-docs:
	echo "---\nsort: ${ORDER}\n---\n" > ${DST}
	cat ${SRC} >> ${DST}

# Copies docs for all components and adds the order tag.
# Cluster docs are supposed to be ordered as 9th.
# For The rest of docs is ordered manually.t
docs-sync:
	cp README.md docs/README.md
	SRC=README.md DST=docs/Single-server-VictoriaMetrics.md ORDER=1 $(MAKE) copy-docs
	SRC=app/vmagent/README.md DST=docs/vmagent.md ORDER=3 $(MAKE) copy-docs
	SRC=app/vmalert/README.md DST=docs/vmalert.md ORDER=4 $(MAKE) copy-docs
	SRC=app/vmauth/README.md DST=docs/vmauth.md ORDER=5 $(MAKE) copy-docs
	SRC=app/vmbackup/README.md DST=docs/vmbackup.md ORDER=6 $(MAKE) copy-docs
	SRC=app/vmrestore/README.md DST=docs/vmrestore.md ORDER=7 $(MAKE) copy-docs
	SRC=app/vmctl/README.md DST=docs/vmctl.md ORDER=8 $(MAKE) copy-docs
	SRC=app/vmgateway/README.md DST=docs/vmgateway.md ORDER=9 $(MAKE) copy-docs
	SRC=app/vmbackupmanager/README.md DST=docs/vmbackupmanager.md ORDER=10 $(MAKE) copy-docs

=== app/victoria-metrics/Makefile ===
# All these commands must run from repository root.

victoria-metrics:
	APP_NAME=victoria-metrics $(MAKE) app-local

victoria-metrics-race:
	APP_NAME=victoria-metrics RACE=-race $(MAKE) app-local

victoria-metrics-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker

victoria-metrics-pure-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-pure

victoria-metrics-amd64-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-amd64

victoria-metrics-arm-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-arm

victoria-metrics-arm64-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-arm64

victoria-metrics-ppc64le-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-ppc64le

victoria-metrics-386-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-386

victoria-metrics-darwin-amd64-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-darwin-amd64

victoria-metrics-darwin-arm64-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-darwin-arm64

package-victoria-metrics:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker

package-victoria-metrics-pure:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker-pure

package-victoria-metrics-amd64:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker-amd64

package-victoria-metrics-arm:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker-arm

package-victoria-metrics-arm64:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker-arm64

package-victoria-metrics-ppc64le:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker-ppc64le

package-victoria-metrics-386:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker-386

publish-victoria-metrics:
	APP_NAME=victoria-metrics $(MAKE) publish-via-docker

run-victoria-metrics:
	mkdir -p victoria-metrics-data
	DOCKER_OPTS='-v $(shell pwd)/victoria-metrics-data:/victoria-metrics-data' \
	APP_NAME=victoria-metrics \
	ARGS='-graphiteListenAddr=:2003 -opentsdbListenAddr=:4242 -retentionPeriod=12 -search.maxUniqueTimeseries=1000000 -search.maxQueryDuration=10m' \
	$(MAKE) run-via-docker

victoria-metrics-amd64:
	CGO_ENABLED=1 GOOS=linux GOARCH=amd64 GO111MODULE=on go build -mod=vendor -ldflags "$(GO_BUILDINFO)" -o bin/victoria-metrics-amd64 ./app/victoria-metrics

victoria-metrics-arm:
	CGO_ENABLED=0 GOOS=linux GOARCH=arm GO111MODULE=on go build -mod=vendor -ldflags "$(GO_BUILDINFO)" -o bin/victoria-metrics-arm ./app/victoria-metrics

victoria-metrics-arm64:
	CGO_ENABLED=0 GOOS=linux GOARCH=arm64 GO111MODULE=on go build -mod=vendor -ldflags "$(GO_BUILDINFO)" -o bin/victoria-metrics-arm64 ./app/victoria-metrics

victoria-metrics-ppc64le:
	CGO_ENABLED=0 GOOS=linux GOARCH=ppc64le GO111MODULE=on go build -mod=vendor -ldflags "$(GO_BUILDINFO)" -o bin/victoria-metrics-ppc64le ./app/victoria-metrics

victoria-metrics-386:
	CGO_ENABLED=0 GOOS=linux GOARCH=386 GO111MODULE=on go build -mod=vendor -ldflags "$(GO_BUILDINFO)" -o bin/victoria-metrics-386 ./app/victoria-metrics

victoria-metrics-pure:
	APP_NAME=victoria-metrics $(MAKE) app-local-pure

### Packaging as DEB - amd64
victoria-metrics-package-deb: victoria-metrics-prod
	./package/package_deb.sh amd64

### Packaging as DEB - arm64
victoria-metrics-package-deb-arm64: victoria-metrics-arm64-prod
	./package/package_deb.sh arm64

### Packaging as DEB - all
victoria-metrics-package-deb-all: \
        victoria-metrics-package-deb \
        victoria-metrics-package-deb-arm64

### Packaging as RPM - amd64
victoria-metrics-package-rpm: victoria-metrics-prod
	./package/package_rpm.sh amd64

### Packaging as RPM - arm64
victoria-metrics-package-rpm-arm64: victoria-metrics-arm64-prod
	./package/package_rpm.sh arm64

### Packaging as RPM - all
victoria-metrics-package-rpm-all: \
        victoria-metrics-package-rpm \
        victoria-metrics-package-rpm-arm64

### Packaging as both DEB and RPM - all
victoria-metrics-package-deb-rpm-all: \
        victoria-metrics-package-deb \
        victoria-metrics-package-deb-arm64 \
        victoria-metrics-package-rpm \
        victoria-metrics-package-rpm-arm64

### Packaging as snap
victoria-metrics-package-snap:
	which snapcraft || snap install snapcraft
	which multipass || snap install multipass
	snapcraft

=== app/vmagent/Makefile ===
# All these commands must run from repository root.

vmagent:
	APP_NAME=vmagent $(MAKE) app-local

vmagent-race:
	APP_NAME=vmagent RACE=-race $(MAKE) app-local

vmagent-prod:
	APP_NAME=vmagent $(MAKE) app-via-docker

vmagent-pure-prod:
	APP_NAME=vmagent $(MAKE) app-via-docker-pure

vmagent-amd64-prod:
	APP_NAME=vmagent $(MAKE) app-via-docker-amd64

vmagent-arm-prod:
	APP_NAME=vmagent $(MAKE) app-via-docker-arm

vmagent-arm64-prod:
	APP_NAME=vmagent $(MAKE) app-via-docker-arm64

vmagent-ppc64le-prod:
	APP_NAME=vmagent $(MAKE) app-via-docker-ppc64le

vmagent-386-prod:
	APP_NAME=vmagent $(MAKE) app-via-docker-386

vmagent-darwin-amd64-prod:
	APP_NAME=vmagent $(MAKE) app-via-docker-darwin-amd64

vmagent-darwin-arm64-prod:
	APP_NAME=vmagent $(MAKE) app-via-docker-darwin-arm64

vmagent-windows-amd64-prod:
	APP_NAME=vmagent $(MAKE) app-via-docker-windows-amd64

package-vmagent:
	APP_NAME=vmagent $(MAKE) package-via-docker

package-vmagent-pure:
	APP_NAME=vmagent $(MAKE) package-via-docker-pure

package-vmagent-amd64:
	APP_NAME=vmagent $(MAKE) package-via-docker-amd64

package-vmagent-arm:
	APP_NAME=vmagent $(MAKE) package-via-docker-arm

package-vmagent-arm64:
	APP_NAME=vmagent $(MAKE) package-via-docker-arm64

package-vmagent-ppc64le:
	APP_NAME=vmagent $(MAKE) package-via-docker-ppc64le

package-vmagent-386:
	APP_NAME=vmagent $(MAKE) package-via-docker-386

publish-vmagent:
	APP_NAME=vmagent $(MAKE) publish-via-docker

run-vmagent:
	mkdir -p vmagent-remotewrite-data
	DOCKER_OPTS='-v $(shell pwd)/vmagent-remotewrite-data:/vmagent-remotewrite-data' \
	ARGS='-remoteWrite.url=http://localhost:8428/api/v1/write' \
	APP_NAME=vmagent \
	$(MAKE) run-via-docker

vmagent-amd64:
	CGO_ENABLED=1 GOARCH=amd64 $(MAKE) vmagent-local-with-goarch

vmagent-arm:
	CGO_ENABLED=0 GOARCH=arm $(MAKE) vmagent-local-with-goarch

vmagent-arm64:
	CGO_ENABLED=0 GOARCH=arm64 $(MAKE) vmagent-local-with-goarch

vmagent-ppc64le:
	CGO_ENABLED=0 GOARCH=ppc64le $(MAKE) vmagent-local-with-goarch

vmagent-386:
	CGO_ENABLED=0 GOARCH=386 $(MAKE) vmagent-local-with-goarch

vmagent-local-with-goarch:
	APP_NAME=vmagent $(MAKE) app-local-with-goarch

vmagent-pure:
	APP_NAME=vmagent $(MAKE) app-local-pure

vmagent-windows-amd64:
	GOARCH=amd64 APP_NAME=vmagent $(MAKE) app-local-windows-with-goarch

=== app/vmalert/Makefile ===
# All these commands must run from repository root.

vmalert:
	APP_NAME=vmalert $(MAKE) app-local

vmalert-race:
	APP_NAME=vmalert RACE=-race $(MAKE) app-local

vmalert-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker

vmalert-pure-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-pure

vmalert-amd64-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-amd64

vmalert-arm-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-arm

vmalert-arm64-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-arm64

vmalert-ppc64le-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-ppc64le

vmalert-386-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-386

vmalert-darwin-amd64-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-darwin-amd64

vmalert-darwin-arm64-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-darwin-arm64

vmalert-windows-amd64-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-windows-amd64

package-vmalert:
	APP_NAME=vmalert $(MAKE) package-via-docker

package-vmalert-pure:
	APP_NAME=vmalert $(MAKE) package-via-docker-pure

package-vmalert-amd64:
	APP_NAME=vmalert $(MAKE) package-via-docker-amd64

package-vmalert-arm:
	APP_NAME=vmalert $(MAKE) package-via-docker-arm

package-vmalert-arm64:
	APP_NAME=vmalert $(MAKE) package-via-docker-arm64

package-vmalert-ppc64le:
	APP_NAME=vmalert $(MAKE) package-via-docker-ppc64le

package-vmalert-386:
	APP_NAME=vmalert $(MAKE) package-via-docker-386

publish-vmalert:
	APP_NAME=vmalert $(MAKE) publish-via-docker

test-vmalert:
	go test -v -race -cover ./app/vmalert -loggerLevel=ERROR
	go test -v -race -cover ./app/vmalert/datasource
	go test -v -race -cover ./app/vmalert/notifier
	go test -v -race -cover ./app/vmalert/config
	go test -v -race -cover ./app/vmalert/remotewrite

run-vmalert: vmalert
	./bin/vmalert -rule=app/vmalert/config/testdata/rules2-good.rules \
		-datasource.url=http://localhost:8428 \
		-notifier.url=http://localhost:9093 \
		-notifier.url=http://127.0.0.1:9093 \
		-remoteWrite.url=http://localhost:8428 \
		-remoteRead.url=http://localhost:8428 \
		-external.label=cluster=east-1 \
		-external.label=replica=a \
		-evaluationInterval=3s \
		-rule.configCheckInterval=10s

run-vmalert-sd: vmalert
	./bin/vmalert -rule=app/vmalert/config/testdata/rules2-good.rules \
		-datasource.url=http://localhost:8428 \
		-remoteWrite.url=http://localhost:8428 \
		-notifier.config=app/vmalert/notifier/testdata/consul.good.yaml \
		-configCheckInterval=10s

replay-vmalert: vmalert
	./bin/vmalert -rule=app/vmalert/config/testdata/rules-replay-good.rules \
		-datasource.url=http://localhost:8428 \
		-remoteWrite.url=http://localhost:8428 \
		-external.label=cluster=east-1 \
		-external.label=replica=a \
		-replay.timeFrom=2021-05-11T07:21:43Z \
		-replay.timeTo=2021-05-29T18:40:43Z

vmalert-amd64:
	CGO_ENABLED=1 GOARCH=amd64 $(MAKE) vmalert-local-with-goarch

vmalert-arm:
	CGO_ENABLED=0 GOARCH=arm $(MAKE) vmalert-local-with-goarch

vmalert-arm64:
	CGO_ENABLED=0 GOARCH=arm64 $(MAKE) vmalert-local-with-goarch

vmalert-ppc64le:
	CGO_ENABLED=0 GOARCH=ppc64le $(MAKE) vmalert-local-with-goarch

vmalert-386:
	CGO_ENABLED=0 GOARCH=386 $(MAKE) vmalert-local-with-goarch

vmalert-local-with-goarch:
	APP_NAME=vmalert $(MAKE) app-local-with-goarch

vmalert-pure:
	APP_NAME=vmalert $(MAKE) app-local-pure

vmalert-windows-amd64:
	GOARCH=amd64 APP_NAME=vmalert $(MAKE) app-local-windows-with-goarch

=== app/vmauth/Makefile ===
# All these commands must run from repository root.

vmauth:
	APP_NAME=vmauth $(MAKE) app-local

vmauth-race:
	APP_NAME=vmauth RACE=-race $(MAKE) app-local

vmauth-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker

vmauth-pure-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-pure

vmauth-amd64-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-amd64

vmauth-arm-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-arm

vmauth-arm64-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-arm64

vmauth-ppc64le-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-ppc64le

vmauth-386-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-386

vmauth-darwin-amd64-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-darwin-amd64

vmauth-darwin-arm64-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-darwin-arm64

vmauth-windows-amd64-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-windows-amd64

package-vmauth:
	APP_NAME=vmauth $(MAKE) package-via-docker

package-vmauth-pure:
	APP_NAME=vmauth $(MAKE) package-via-docker-pure

package-vmauth-amd64:
	APP_NAME=vmauth $(MAKE) package-via-docker-amd64

package-vmauth-arm:
	APP_NAME=vmauth $(MAKE) package-via-docker-arm

package-vmauth-arm64:
	APP_NAME=vmauth $(MAKE) package-via-docker-arm64

package-vmauth-ppc64le:
	APP_NAME=vmauth $(MAKE) package-via-docker-ppc64le

package-vmauth-386:
	APP_NAME=vmauth $(MAKE) package-via-docker-386

publish-vmauth:
	APP_NAME=vmauth $(MAKE) publish-via-docker

run-vmauth:
	APP_NAME=vmauth \
	DOCKER_OPTS='-v $(shell pwd)/app/vmauth/:/app/vmauth' \
	ARGS='-auth.config=app/vmauth/example_config.yml' \
	$(MAKE) run-via-docker

vmauth-amd64:
	CGO_ENABLED=1 GOARCH=amd64 $(MAKE) vmauth-local-with-goarch

vmauth-arm:
	CGO_ENABLED=0 GOARCH=arm $(MAKE) vmauth-local-with-goarch

vmauth-arm64:
	CGO_ENABLED=0 GOARCH=arm64 $(MAKE) vmauth-local-with-goarch

vmauth-ppc64le:
	CGO_ENABLED=0 GOARCH=ppc64le $(MAKE) vmauth-local-with-goarch

vmauth-386:
	CGO_ENABLED=0 GOARCH=386 $(MAKE) vmauth-local-with-goarch

vmauth-local-with-goarch:
	APP_NAME=vmauth $(MAKE) app-local-with-goarch

vmauth-pure:
	APP_NAME=vmauth $(MAKE) app-local-pure

vmauth-windows-amd64:
	GOARCH=amd64 APP_NAME=vmauth $(MAKE) app-local-windows-with-goarch

=== app/vmbackup/Makefile ===
# All these commands must run from repository root.

vmbackup:
	APP_NAME=vmbackup $(MAKE) app-local

vmbackup-race:
	APP_NAME=vmbackup RACE=-race $(MAKE) app-local

vmbackup-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker

vmbackup-pure-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-pure

vmbackup-amd64-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-amd64

vmbackup-arm-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-arm

vmbackup-arm64-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-arm64

vmbackup-ppc64le-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-ppc64le

vmbackup-386-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-386

vmbackup-darwin-amd64-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-darwin-amd64

vmbackup-darwin-arm64-prod:
	APP_NAME=vmbackup $(MAKE) app-via-docker-darwin-arm64

package-vmbackup:
	APP_NAME=vmbackup $(MAKE) package-via-docker

package-vmbackup-pure:
	APP_NAME=vmbackup $(MAKE) package-via-docker-pure

package-vmbackup-amd64:
	APP_NAME=vmbackup $(MAKE) package-via-docker-amd64

package-vmbackup-arm:
	APP_NAME=vmbackup $(MAKE) package-via-docker-arm

package-vmbackup-arm64:
	APP_NAME=vmbackup $(MAKE) package-via-docker-arm64

package-vmbackup-ppc64le:
	APP_NAME=vmbackup $(MAKE) package-via-docker-ppc64le

package-vmbackup-386:
	APP_NAME=vmbackup $(MAKE) package-via-docker-386

publish-vmbackup:
	APP_NAME=vmbackup $(MAKE) publish-via-docker

vmbackup-amd64:
	CGO_ENABLED=1 GOARCH=amd64 $(MAKE) vmbackup-local-with-goarch

vmbackup-arm:
	CGO_ENABLED=0 GOARCH=arm $(MAKE) vmbackup-local-with-goarch

vmbackup-arm64:
	CGO_ENABLED=0 GOARCH=arm64 $(MAKE) vmbackup-local-with-goarch

vmbackup-ppc64le:
	CGO_ENABLED=0 GOARCH=ppc64le $(MAKE) vmbackup-local-with-goarch

vmbackup-386:
	CGO_ENABLED=0 GOARCH=386 $(MAKE) vmbackup-local-with-goarch

vmbackup-local-with-goarch:
	APP_NAME=vmbackup $(MAKE) app-local-with-goarch

vmbackup-pure:
	APP_NAME=vmbackup $(MAKE) app-local-pure

=== app/vmctl/Makefile ===
# All these commands must run from repository root.

vmctl:
	APP_NAME=vmctl $(MAKE) app-local

vmctl-race:
	APP_NAME=vmctl RACE=-race $(MAKE) app-local

vmctl-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker

vmctl-pure-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-pure

vmctl-amd64-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-amd64

vmctl-arm-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-arm

vmctl-arm64-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-arm64

vmctl-ppc64le-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-ppc64le

vmctl-386-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-386

vmctl-darwin-amd64-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-darwin-amd64

vmctl-darwin-arm64-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-darwin-arm64

vmctl-windows-amd64-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-windows-amd64

package-vmctl:
	APP_NAME=vmctl $(MAKE) package-via-docker

package-vmctl-pure:
	APP_NAME=vmctl $(MAKE) package-via-docker-pure

package-vmctl-amd64:
	APP_NAME=vmctl $(MAKE) package-via-docker-amd64

package-vmctl-arm:
	APP_NAME=vmctl $(MAKE) package-via-docker-arm

package-vmctl-arm64:
	APP_NAME=vmctl $(MAKE) package-via-docker-arm64

package-vmctl-ppc64le:
	APP_NAME=vmctl $(MAKE) package-via-docker-ppc64le

package-vmctl-386:
	APP_NAME=vmctl $(MAKE) package-via-docker-386

publish-vmctl:
	APP_NAME=vmctl $(MAKE) publish-via-docker

vmctl-amd64:
	CGO_ENABLED=1 GOARCH=amd64 $(MAKE) vmctl-local-with-goarch

vmctl-arm:
	CGO_ENABLED=0 GOARCH=arm $(MAKE) vmctl-local-with-goarch

vmctl-arm64:
	CGO_ENABLED=0 GOARCH=arm64 $(MAKE) vmctl-local-with-goarch

vmctl-ppc64le:
	CGO_ENABLED=0 GOARCH=ppc64le $(MAKE) vmctl-local-with-goarch

vmctl-386:
	CGO_ENABLED=0 GOARCH=386 $(MAKE) vmctl-local-with-goarch

vmctl-local-with-goarch:
	APP_NAME=vmctl $(MAKE) app-local-with-goarch

vmctl-pure:
	APP_NAME=vmctl $(MAKE) app-local-pure

vmctl-windows-amd64:
	GOARCH=amd64 APP_NAME=vmctl $(MAKE) app-local-windows-with-goarch

=== app/vmrestore/Makefile ===
# All these commands must run from repository root.

vmrestore:
	APP_NAME=vmrestore $(MAKE) app-local

vmrestore-race:
	APP_NAME=vmrestore RACE=-race $(MAKE) app-local

vmrestore-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker

vmrestore-pure-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-pure

vmrestore-amd64-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-amd64

vmrestore-arm-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-arm

vmrestore-arm64-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-arm64

vmrestore-ppc64le-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-ppc64le

vmrestore-386-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-386

vmrestore-darwin-amd64-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-darwin-amd64

vmrestore-darwin-arm64-prod:
	APP_NAME=vmrestore $(MAKE) app-via-docker-darwin-arm64

package-vmrestore:
	APP_NAME=vmrestore $(MAKE) package-via-docker

package-vmrestore-pure:
	APP_NAME=vmrestore $(MAKE) package-via-docker-pure

package-vmrestore-amd64:
	APP_NAME=vmrestore $(MAKE) package-via-docker-amd64

package-vmrestore-arm:
	APP_NAME=vmrestore $(MAKE) package-via-docker-arm

package-vmrestore-arm64:
	APP_NAME=vmrestore $(MAKE) package-via-docker-arm64

package-vmrestore-ppc64le:
	APP_NAME=vmrestore $(MAKE) package-via-docker-ppc64le

package-vmrestore-386:
	APP_NAME=vmrestore $(MAKE) package-via-docker-386

publish-vmrestore:
	APP_NAME=vmrestore $(MAKE) publish-via-docker

vmrestore-amd64:
	CGO_ENABLED=1 GOARCH=amd64 $(MAKE) vmrestore-local-with-goarch

vmrestore-arm:
	CGO_ENABLED=0 GOARCH=arm $(MAKE) vmrestore-local-with-goarch

vmrestore-arm64:
	CGO_ENABLED=0 GOARCH=arm64 $(MAKE) vmrestore-local-with-goarch

vmrestore-ppc64le:
	CGO_ENABLED=0 GOARCH=ppc64le $(MAKE) vmrestore-local-with-goarch

vmrestore-386:
	CGO_ENABLED=0 GOARCH=386 $(MAKE) vmrestore-local-with-goarch

vmrestore-local-with-goarch:
	APP_NAME=vmrestore $(MAKE) app-local-with-goarch

vmrestore-pure:
	APP_NAME=vmrestore $(MAKE) app-local-pure

=== deployment/docker/Makefile ===
# All these commands must run from repository root.

DOCKER_NAMESPACE := victoriametrics

ROOT_IMAGE ?= alpine:3.15.0
CERTS_IMAGE := alpine:3.15.0
GO_BUILDER_IMAGE := golang:1.18.0-alpine
BUILDER_IMAGE := local/builder:2.0.0-$(shell echo $(GO_BUILDER_IMAGE) | tr :/ __)-1
BASE_IMAGE := local/base:1.1.3-$(shell echo $(ROOT_IMAGE) | tr :/ __)-$(shell echo $(CERTS_IMAGE) | tr :/ __)

package-base:
	(docker image ls --format '{{.Repository}}:{{.Tag}}' | grep -q '$(BASE_IMAGE)$$') \
		|| docker build \
			--build-arg root_image=$(ROOT_IMAGE) \
			--build-arg certs_image=$(CERTS_IMAGE) \
			--tag $(BASE_IMAGE) \
			deployment/docker/base

package-builder:
	(docker image ls --format '{{.Repository}}:{{.Tag}}' | grep -q '$(BUILDER_IMAGE)$$') \
		|| docker build \
			--build-arg go_builder_image=$(GO_BUILDER_IMAGE) \
			--tag $(BUILDER_IMAGE) \
			deployment/docker/builder

app-via-docker: package-builder
	mkdir -p gocache-for-docker
	docker run --rm \
		--user $(shell id -u):$(shell id -g) \
		--mount type=bind,src="$(shell pwd)",dst=/VictoriaMetrics \
		-w /VictoriaMetrics \
		--mount type=bind,src="$(shell pwd)/gocache-for-docker",dst=/gocache \
		--env GOCACHE=/gocache \
		--env GO111MODULE=on \
		$(DOCKER_OPTS) \
		$(BUILDER_IMAGE) \
		go build $(RACE) -mod=vendor -trimpath \
			-ldflags "-extldflags '-static' $(GO_BUILDINFO)" \
			-tags 'netgo osusergo nethttpomithttp2 musl' \
			-o bin/$(APP_NAME)$(APP_SUFFIX)-prod $(PKG_PREFIX)/app/$(APP_NAME)

app-via-docker-windows: package-builder
	mkdir -p gocache-for-docker
	docker run --rm \
		--user $(shell id -u):$(shell id -g) \
		--mount type=bind,src="$(shell pwd)",dst=/VictoriaMetrics \
		-w /VictoriaMetrics \
		--mount type=bind,src="$(shell pwd)/gocache-for-docker",dst=/gocache \
		--env GOCACHE=/gocache \
		--env GO111MODULE=on \
		$(DOCKER_OPTS) \
		$(BUILDER_IMAGE) \
		go build $(RACE) -mod=vendor -trimpath \
			-ldflags "-s -w -extldflags '-static' $(GO_BUILDINFO)" \
			-tags 'netgo osusergo nethttpomithttp2' \
			-o bin/$(APP_NAME)-windows$(APP_SUFFIX)-prod.exe $(PKG_PREFIX)/app/$(APP_NAME)

package-via-docker: package-base
	(docker image ls --format '{{.Repository}}:{{.Tag}}' | grep -q '$(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)$(APP_SUFFIX)$(RACE)$$') || (\
		$(MAKE) app-via-docker && \
		docker build \
			--build-arg src_binary=$(APP_NAME)$(APP_SUFFIX)-prod \
			--build-arg base_image=$(BASE_IMAGE) \
			--tag $(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)$(APP_SUFFIX)$(RACE) \
			-f app/$(APP_NAME)/deployment/Dockerfile bin)

publish-via-docker: \
	app-via-docker-amd64 \
	app-via-docker-arm \
	app-via-docker-arm64 \
	app-via-docker-ppc64le \
	app-via-docker-386
	docker buildx build \
		--platform=linux/amd64,linux/arm,linux/arm64,linux/ppc64le,linux/386 \
		--build-arg certs_image=$(CERTS_IMAGE) \
		--build-arg root_image=$(ROOT_IMAGE) \
		--build-arg APP_NAME=$(APP_NAME) \
		--tag $(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)$(RACE) \
		--tag $(DOCKER_NAMESPACE)/$(APP_NAME):latest$(RACE) \
		-o type=image \
		-f app/$(APP_NAME)/multiarch/Dockerfile \
		--push \
		bin

run-via-docker: package-via-docker
	docker run -it --rm \
		--user $(shell id -u):$(shell id -g) \
		--net host \
		$(DOCKER_OPTS) \
		$(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)$(APP_SUFFIX)$(RACE) $(ARGS)

app-via-docker-goarch:
	APP_SUFFIX='-$(GOARCH)' \
	DOCKER_OPTS='--env CGO_ENABLED=$(CGO_ENABLED) --env GOOS=linux --env GOARCH=$(GOARCH)' \
	$(MAKE) app-via-docker

app-via-docker-darwin-amd64:
	CGO_ENABLED=0 GOOS=darwin GOARCH=amd64 $(MAKE) app-via-docker-goos-goarch

app-via-docker-darwin-arm64:
	CGO_ENABLED=0 GOOS=darwin GOARCH=arm64 $(MAKE) app-via-docker-goos-goarch

app-via-docker-goos-goarch:
	APP_SUFFIX='-$(GOOS)-$(GOARCH)' \
	DOCKER_OPTS='--env CGO_ENABLED=$(CGO_ENABLED) --env GOOS=$(GOOS) --env GOARCH=$(GOARCH)' \
	$(MAKE) app-via-docker

app-via-docker-goarch-arm64:
	APP_SUFFIX='-arm64' \
	DOCKER_OPTS='--env CGO_ENABLED=1 --env GOOS=linux --env GOARCH=arm64 --env CC=/opt/cross-builder/aarch64-linux-musl-cross/bin/aarch64-linux-musl-gcc' \
	$(MAKE) app-via-docker

app-via-docker-windows-goarch:
	APP_SUFFIX='-$(GOARCH)' \
	DOCKER_OPTS='--env CGO_ENABLED=0 --env GOOS=windows --env GOARCH=$(GOARCH)' \
	$(MAKE) app-via-docker-windows

app-via-docker-goarch-cgo:
	CGO_ENABLED=1 $(MAKE) app-via-docker-goarch

app-via-docker-goarch-nocgo:
	CGO_ENABLED=0 $(MAKE) app-via-docker-goarch

app-via-docker-pure:
	APP_SUFFIX='-pure' DOCKER_OPTS='--env CGO_ENABLED=0' $(MAKE) app-via-docker

app-via-docker-amd64:
	GOARCH=amd64 $(MAKE) app-via-docker-goarch-cgo

app-via-docker-arm:
	GOARCH=arm $(MAKE) app-via-docker-goarch-nocgo

app-via-docker-arm64:
ifeq ($(APP_NAME),vmagent)
	GOARCH=arm64 $(MAKE) app-via-docker-goarch-nocgo
else
	$(MAKE) app-via-docker-goarch-arm64
endif

app-via-docker-ppc64le:
	GOARCH=ppc64le $(MAKE) app-via-docker-goarch-nocgo

app-via-docker-386:
	GOARCH=386 $(MAKE) app-via-docker-goarch-nocgo

app-via-docker-windows-amd64:
	GOARCH=amd64 $(MAKE) app-via-docker-windows-goarch

package-via-docker-goarch:
	APP_SUFFIX='-$(GOARCH)' \
	DOCKER_OPTS='--env CGO_ENABLED=$(CGO_ENABLED) --env GOOS=linux --env GOARCH=$(GOARCH)' \
	$(MAKE) package-via-docker

package-via-docker-goarch-arm64:
	APP_SUFFIX='-arm64' \
	DOCKER_OPTS='--env CGO_ENABLED=1 --env GOOS=linux --env GOARCH=arm64 --env CC=/opt/cross-builder/aarch64-linux-musl-cross/bin/aarch64-linux-musl-gcc' \
	$(MAKE) package-via-docker

package-via-docker-goarch-cgo:
	CGO_ENABLED=1 $(MAKE) package-via-docker-goarch

package-via-docker-goarch-nocgo:
	CGO_ENABLED=0 $(MAKE) package-via-docker-goarch

package-via-docker-pure:
	APP_SUFFIX='-pure' DOCKER_OPTS='--env CGO_ENABLED=0' $(MAKE) package-via-docker

package-via-docker-amd64:
	GOARCH=amd64 $(MAKE) package-via-docker-goarch-cgo

package-via-docker-arm:
	GOARCH=arm $(MAKE) package-via-docker-goarch-nocgo

package-via-docker-arm64:
ifeq ($(APP_NAME),vmagent)
	GOARCH=arm64 $(MAKE) package-via-docker-goarch-nocgo
else
	$(MAKE) package-via-docker-goarch-arm64
endif


package-via-docker-ppc64le:
	GOARCH=ppc64le $(MAKE) package-via-docker-goarch-nocgo

package-via-docker-386:
	GOARCH=386 $(MAKE) package-via-docker-goarch-nocgo

remove-docker-images:
	docker image ls --format '{{.Repository}}\t{{.ID}}' | awk '{print $$2}' | xargs docker image rm -f

=== snap/local/Makefile ===
GO_VERSION ?=1.17.7
SNAP_BUILDER_IMAGE := local/snap-builder:2.0.0-$(shell echo $(GO_VERSION) | tr :/ __)


# truncate pkg_tag, snap has limitations for name length
SNAP_TAG := $(shell echo "$(PKG_TAG)" | cut -b1-31 )

snap-builder-image:
	(docker image ls --format '{{.Repository}}:{{.Tag}}' | grep -q '$(SNAP_BUILDER_IMAGE)$$') \
	|| docker build \
		--build-arg GO_VERSION=$(GO_VERSION) \
		--tag $(SNAP_BUILDER_IMAGE) \
		snap/local

build-snap: snap-builder-image
	docker run --rm \
		--mount type=bind,src="$(shell pwd)",dst=/builder \
		-w /builder \
		--env PKG_TAG=$(SNAP_TAG) \
		$(SNAP_BUILDER_IMAGE) \
		bash -c 'snapcraft clean && snapcraft snap -o bin/'

release-snap: snap-builder-image build-snap
	docker run --rm \
		--mount type=bind,src=${HOME}/.snap,dst=/root/.snap \
		--mount type=bind,src="$(shell pwd)",dst=/builder \
		-w /builder \
		--env PKG_TAG=$(SNAP_TAG) \
		$(SNAP_BUILDER_IMAGE) \
		bash -c 'snapcraft login --with /root/.snap/login.json && snapcraft upload "bin/victoriametrics_$(SNAP_TAG)_multi.snap" --release beta,edge,candidate,stable'

=== debian/changelog ===
victoriametrics (1.75.0+ds1-1ubuntu0.1) kinetic-security; urgency=medium

  * No-change rebuild for golang-golang-x-text

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Tue, 14 Feb 2023 15:58:01 +0100

victoriametrics (1.75.0+ds1-1) unstable; urgency=medium

  * New upstream release.

 -- Guillem Jover <gjover@sipwise.com>  Tue, 22 Mar 2022 17:27:10 +0100

victoriametrics (1.74.0+ds1-1) unstable; urgency=medium

  * New upstream release.
  * Switch from vendored module to golang-github-cheggaaa-pb.v3-dev.
  * Refresh system xxhash patch.
  * Update defaults file for new upstream release.

 -- Guillem Jover <gjover@sipwise.com>  Mon, 14 Mar 2022 15:38:15 +0100

=== debian/control ===
Source: victoriametrics
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Guillem Jover <gjover@sipwise.com>,
Section: net
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-golang,
 golang-any,
 golang-github-aws-aws-sdk-go-dev,
 golang-github-cespare-xxhash-dev (>= 2.1.1~),
 golang-github-cheggaaa-pb.v3-dev,
 golang-github-golang-snappy-dev,
 golang-github-klauspost-compress-dev (>= 1.9.5~),
 golang-github-urfave-cli-v2-dev,
 golang-github-valyala-fastjson-dev (>= 1.6.1~),
 golang-github-valyala-fastrand-dev <!nocheck>,
 golang-github-valyala-fasttemplate-dev,
 golang-github-valyala-gozstd-dev,
 golang-github-valyala-histogram-dev,
 golang-github-valyala-quicktemplate-dev,
 golang-github-victoriametrics-fastcache-dev (>= 1.8.0~),
 golang-github-victoriametrics-metrics-dev (>= 1.12.3~),
 golang-github-victoriametrics-metricsql-dev (>= 0.34.0~),
 golang-golang-x-oauth2-google-dev,
 golang-golang-x-sys-dev,
 golang-google-api-dev (>= 0.15.0~),
 golang-google-cloud-dev (>= 0.49.0~),
 golang-gopkg-yaml.v2-dev,
# Needed by vendored module (github.com/prometheus/prometheus/)
 golang-github-go-kit-kit-dev,
 golang-github-oklog-ulid-dev,
 golang-github-pkg-errors-dev,
 golang-github-prometheus-client-golang-dev,
 golang-github-prometheus-common-dev,
 golang-go.uber-atomic-dev,
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/victoriametrics
Vcs-Git: https://salsa.debian.org/go-team/packages/victoriametrics.git
Homepage: https://github.com/VictoriaMetrics/VictoriaMetrics
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/VictoriaMetrics/VictoriaMetrics

Package: victoria-metrics
Architecture: any
Multi-Arch: foreign
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 adduser,
 ${misc:Depends},
 ${shlibs:Depends},
Built-Using: ${misc:Built-Using}
Description: fast, cost-effective and scalable time series database
 VictoriaMetrics is a fast, cost-effective and scalable time-series database.
 It can be used as long-term remote storage for Prometheus.
 .
 Prominent features:
  * Supports Prometheus querying API, so it can be used as Prometheus
    drop-in replacement in Grafana. VictoriaMetrics implements MetricsQL
    query language, which is inspired by PromQL.
  * Supports global query view. Multiple Prometheus instances may write
    data into VictoriaMetrics. Later this data may be used in a single query.
  * High performance and good scalability for both inserts and selects.
    Outperforms InfluxDB and TimescaleDB by up to 20x.
  * Uses 10x less RAM than InfluxDB when working with millions of unique time
    series (aka high cardinality).
  * Optimized for time series with high churn rate. Think about
    prometheus-operator metrics from frequent deployments in Kubernetes.
  * High data compression, so up to 70x more data points may be crammed into
    limited storage comparing to TimescaleDB.
  * Optimized for storage with high-latency IO and low IOPS (HDD and network
    storage in AWS, Google Cloud, Microsoft Azure, etc).
  * A single-node VictoriaMetrics may substitute moderately sized clusters
    built with competing solutions such as Thanos, M3DB, Cortex, InfluxDB or
    TimescaleDB.
  * Easy operation:
    - VictoriaMetrics consists of a single small executable without external
      dependencies.
    - All the configuration is done via explicit command-line flags with
      reasonable defaults.
    - All the data is stored in a single directory pointed by
      -storageDataPath flag.
    - Easy and fast backups from instant snapshots to S3 or GCS with
      vmbackup / vmrestore.
    - Data migration between VictoriaMetrics, Prometheus and InfluxDB with
      vmctl.
  * Storage is protectedfrom corruption on unclean shutdown (i.e. OOM,
    hardware reset or kill -9) thanks to the storage architecture.
  * Supports metrics' scraping, ingestion and backfilling (#backfilling)
    via the following protocols:
    - Metrics from Prometheus exporters such as node_exporter.
    - Prometheus remote write API
    - InfluxDB line protocol
    - Graphite plaintext protocol with tags if -graphiteListenAddr is set.
    - OpenTSDB put message if -opentsdbListenAddr is set.
    - HTTP OpenTSDB /api/put requests if -opentsdbHTTPListenAddr is set.
    - /api/v1/import.
  * Ideally works with big amounts of time series data from Kubernetes, IoT
    sensors, connected cars, industrial telemetry, financial data and
    various Enterprise workloads.
  * Has open source cluster version.

Package: golang-github-victoriametrics-victoriametrics-dev
Section: golang
Architecture: all
Multi-Arch: foreign
Depends:
 golang-github-aws-aws-sdk-go-dev,
 golang-github-cespare-xxhash-dev (>= 2.1.1~),
 golang-github-golang-snappy-dev,
 golang-github-klauspost-compress-dev (>= 1.9.5~),
 golang-github-valyala-fasttemplate-dev,
 golang-golang-x-oauth2-google-dev,
 golang-golang-x-sys-dev,
 golang-google-api-dev (>= 0.15.0~),
 golang-google-cloud-dev (>= 0.49.0~),
 golang-gopkg-yaml.v2-dev,
 ${misc:Depends},
Description: fast, cost-effective and scalable time series database (library)
 This package provides the library code for VictoriaMetrics.
